
    #   Load a CSV-defined database into memory

    #	The first non-comment record is taken to be the list of
    #	field names.  Subsequent non-comment lines are stored into
    #	an array of hashes with key of the field name and value
    #	the contents of the field.  Comments, any line whose first
    #	nonblank character is "#" or ";", as well as totally
    #	blank lines are ignored.  CSV fields are parsed
    #	according to the &csv subroutine; if you don't like its
    #	definition, change it.
    
    #	    	    John Walker
    #	    	    April 2004

    sub csvdb {
    	my ($f) = @_;
    	my ($l, $n, @fields, @db, $dbn);
	
	open(FI, "<$f") || die("csvdb: Cannot open CSV database $f");
	$n = 0;
	$dbn = 0;
	while ($l = <FI>) {
	    $l =~ s/\s+$//;
	    $l =~ s/^\s+//;
	    if (($l eq '') || ($l =~ m/^[#;]/)) {
	    	next;
	    }
	    if ($n == 0) {
	    	@fields = &csv($l);
	    } else {
	    	$db[$dbn] = {};
		my @f = &csv($l);
		for ($i = 0;  $i <= $#fields; $i++) {
		    $db[$dbn]{$fields[$i]} = $f[$i];
    	    	}
		$dbn++;
	    }
	    $n++;
	}
	close(FI);
	
#for ($i = 0;  $i < $#fields; $i++) {
#    print("Field $i:  $fields[$i]\n");
#}
    	return @db;
    }
    
    1;
